//+--------------------------------------------------------------------------+
//|                                                                          |
//|                               DWM spinner                                |
//|                                                                          |
//|                      Composited spinner annimation                       |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                            copyright(c) 2014                             |
//|                           www.zapsolution.com                            |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 01-05-2013 (MM-DD-YYYY)            |
//|                        Last revised : 01-06-2013 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

#include <windows.h>
#include <iostream>
using namespace std;

#include <WinBase.h>
#include <Dwmapi.h>

#define TIMER_DELAY   30
#define TIMER_SPINNER -1

// GDIPLUS Flat API
#ifndef _GDIPLUS_H
#define _GDIPLUS_H
    struct IDirectDrawSurface7;
    typedef signed   short  INT16;
    typedef unsigned short  UINT16;
    #include <pshpack8.h>   // set structure packing to 8
    namespace DllExports { 
    #include "GdiplusMem.h"
    };
    #include "GdiplusBase.h"
    #include "GdiplusEnums.h"
    #include "GdiplusTypes.h"
    #include "GdiplusInit.h"
    #include "GdiplusPixelFormats.h"
    #include "GdiplusColor.h"
    #include "GdiplusMetaHeader.h"
    #include "GdiplusImaging.h"
    #include "GdiplusGpStubs.h"
    #include "GdiplusHeaders.h"
#endif // !_GDIPLUS_HPP

LONG_PTR ghImg;
DWORD gn_DELAY;
long gn_W, gn_H, gn_FrameCount, gn_FrameToUse, gn_IsHorizontal;
HDC g_hDC; HBITMAP g_hBitmap; HWND g_hMain;

HMODULE g_GDIPLIB;

#define long_proc typedef long (__stdcall *zProc)

long Load_GDIPLUS() {
    static long nRet;
    if (nRet == 0) {
       g_GDIPLIB = LoadLibrary (L"GDIPLUS");
       if (g_GDIPLIB != 0) { nRet = -1; }
    }
    return nRet;
}

long GdiplusStart (OUT LONG_PTR &hGDIplus, GdiplusStartupInput &inputbuf, IN LONG_PTR outputbuf) {
    long nRet = -1; // Error
    if (g_GDIPLIB) {
        long_proc (LONG_PTR*, GdiplusStartupInput*, LONG_PTR);
        zProc hPROC = (zProc) GetProcAddress(g_GDIPLIB, "GdiplusStartup");
        if (hPROC) { 
            nRet = hPROC(&hGDIplus, &inputbuf, outputbuf);
        }
    }
    return nRet;
}

long GdiplusShutdown (IN LONG_PTR hGDIplus) {
    long nRet = -1; // Error
    if (g_GDIPLIB) {
        long_proc (LONG_PTR);
        zProc hProc = (zProc) GetProcAddress(g_GDIPLIB, "GdiplusShutdown");
        if (hProc) { nRet = hProc(hGDIplus); }
    }
    return nRet;
}

long GdipLoadImageFromFile (IN WCHAR* szImgName, OUT LONG_PTR &lpImg) {
    long nRet = -1; // Error
    lpImg = 0;
    if (g_GDIPLIB) {
        long_proc (WCHAR*, LONG_PTR*);
        zProc hProc = (zProc) GetProcAddress(g_GDIPLIB, "GdipLoadImageFromFile");
        if (hProc) { 
            nRet = hProc(szImgName, &lpImg); 
        }
    }
    return nRet;
}

long GdipDeleteGraphics(IN LONG_PTR graphics) {
    long nRet = -1; // Error
    if (g_GDIPLIB) {
        long_proc (LONG_PTR);
        zProc hProc = (zProc) GetProcAddress(g_GDIPLIB, "GdipDeleteGraphics");
        if (hProc) { nRet = hProc(graphics); }
    }
    return nRet;
}

long GdipDrawImageRectRectI(IN LONG_PTR graphics, IN LONG_PTR lpImg, IN long dstX, IN long dstY, IN long dstW, IN long dstH, IN long srcX, IN long srcY, IN long srcW, IN long srcH, IN long srcUnit, IN LONG_PTR imageattr, IN LONG_PTR lpCallback, IN LONG_PTR callbackdata) {
    long nRet = -1; // Error
    if (g_GDIPLIB) {
        long_proc (LONG_PTR, LONG_PTR, long, long, long, long, long, long, long, long, long, LONG_PTR, LONG_PTR, LONG_PTR);
        zProc hProc = (zProc) GetProcAddress(g_GDIPLIB, "GdipDrawImageRectRectI");
        if (hProc) { nRet = hProc(graphics, lpImg, dstX, dstY, dstW, dstH, srcX, srcY, srcW, srcH, srcUnit, imageattr, lpCallback, callbackdata); }
    }
    return nRet;
}

long GdipDisposeImage(IN LONG_PTR lpImg) {
    long nRet = -1; // Error
    if (g_GDIPLIB) {
        long_proc (LONG_PTR);
        zProc hProc = (zProc) GetProcAddress(g_GDIPLIB, "GdipDisposeImage");
        if (hProc) { nRet = hProc(lpImg); }
    }
    return nRet;
}

long GdipGetImageWidth(IN LONG_PTR lpImg, OUT long &imgW) {
    long nRet = -1; // Error
    imgW = 0;
    if (g_GDIPLIB) {
        long_proc (LONG_PTR, long*);
        zProc hProc = (zProc) GetProcAddress(g_GDIPLIB, "GdipGetImageWidth");
        if (hProc) { nRet = hProc(lpImg, &imgW); }
    }
    return nRet;
}

long GdipGetImageHeight(IN LONG_PTR lpImg, OUT long &imgH) {
    long nRet = -1; // Error
    imgH = 0;
    if (g_GDIPLIB) {
        long_proc (LONG_PTR, long*);
        zProc hProc = (zProc) GetProcAddress(g_GDIPLIB, "GdipGetImageHeight");
        if (hProc) { nRet = hProc(lpImg, &imgH); }
    }
    return nRet;
}

long GdipCreateFromHDC(IN HDC hDC, OUT LONG_PTR &graphics) {
    long nRet = -1; // Error
    graphics = 0;
    if (g_GDIPLIB) {
        long_proc (HDC, LONG_PTR*);
        zProc hProc = (zProc) GetProcAddress(g_GDIPLIB, "GdipCreateFromHDC");
        if (hProc) { nRet = hProc(hDC, &graphics); }
    }
    return nRet;
}

LONG_PTR gdiphandle(IN LONG_PTR hGDIplus, IN long RW) {
    static LONG_PTR wasHandle;
    if (RW) { wasHandle = hGDIplus; }
    return wasHandle;
}

LONG_PTR GdipStart () {
    if (Load_GDIPLUS()) {
        // Load the GDI+ Dll
        GdiplusStartupInput GpInput;
        GpInput.GdiplusVersion = 1;
        LONG_PTR hGDIplus = gdiphandle(0, 0);
        if (hGDIplus == 0) {
            if (GdiplusStart(hGDIplus, GpInput, NULL) == 0) {
                gdiphandle(hGDIplus, 1);
            }
        }
    }
    return gdiphandle(0, 0);
}

void GdipEnd (IN LONG_PTR hGDIplus) {
    if (hGDIplus) { GdiplusShutdown(hGDIplus); }
}

BOOL IsFile(IN WCHAR* szFileSpec) {
    WIN32_FIND_DATA fd = { 0 };
    LPCTSTR lpFileSpec = szFileSpec;
    BOOL bRet = FALSE;
    if (wcslen(szFileSpec)) {
       HANDLE hFind;
       hFind = FindFirstFile(szFileSpec, &fd);
       if (hFind != INVALID_HANDLE_VALUE) {
          FindClose(hFind);
          bRet = TRUE;
       }
    }
    return bRet;
}

// Check for the DWMAPI
HMODULE LoadDWM () {
    static HMODULE hLib;
    static long nChecked;
    if (nChecked == 0) { nChecked = -1; hLib = LoadLibrary (L"DWMAPI"); }
    return hLib;
}

// Enable DWM composition
long zDwmEnableComposition (IN long uCompositionAction) {
    long nRet = 0;
    HMODULE hLib = LoadDWM();
    if (hLib) {
        long_proc (long);
        zProc hProc = (zProc) GetProcAddress(hLib, "DwmEnableComposition");
        if (hProc) { nRet = hProc(uCompositionAction); }
    }
    return nRet;
}

// Check if DWM composition is enabled
long zDwmIsCompositionEnabled () {
    long nRet = 0;
    HMODULE hLib = LoadDWM();
    if (hLib) {
        long_proc (BOOL*);
        zProc hProc = (zProc) GetProcAddress(hLib, "DwmIsCompositionEnabled");
        if (hProc) { 
            BOOL bAero = FALSE;
            if (hProc(&bAero) == 0) {
                if (bAero) { nRet = -1; }
            }
        }
    }
    return nRet;
}

// This is the most IMPORTANT API to create a transparent window
// We fool DWM with a fake region, because we want to use the client, and the non-client area,
// just like with a transparent layered window.
// This one must also be used with Windows 8+
void zSetCrystalBehindMode (IN HWND hWnd, IN BOOL nBOOL) {
    static FARPROC hProc;
    HMODULE hLib = LoadDWM ();
    if (hLib) {
        if (zDwmIsCompositionEnabled()) {
            long_proc (HWND, DWM_BLURBEHIND*);
            zProc hProc = (zProc) GetProcAddress(hLib, "DwmEnableBlurBehindWindow");
            if (hProc) {
                LRESULT nRet = S_OK;
                HRGN hRgnBlur = 0;
                DWM_BLURBEHIND bb = {0};
                // Create and populate the BlurBehind structure.
                // Set Blur Behind and Blur Region.
                bb.fEnable = nBOOL;
                bb.dwFlags = DWM_BB_ENABLE | DWM_BB_BLURREGION;
                bb.fTransitionOnMaximized = 0;
                // Fool DWM with a fake region
                if (nBOOL) { hRgnBlur = CreateRectRgn(-1, -1, 0, 0); }
                bb.hRgnBlur = hRgnBlur;
                // Set Blur Behind mode.
                nRet = hProc(hWnd, &bb);
            }
        }
    }
}

HBITMAP zCreateDIBSection (IN HDC hDC, IN long nWidth, IN long nHeight, IN long nBitCount) { // exportdll
    BITMAPINFO bi = { 0 };
    bi.bmiHeader.biSize = sizeof(bi.bmiHeader);
    bi.bmiHeader.biWidth = nWidth;
    bi.bmiHeader.biHeight = -nHeight;
    bi.bmiHeader.biPlanes = 1;
    bi.bmiHeader.biBitCount = (WORD) nBitCount;
    bi.bmiHeader.biCompression = BI_RGB;
    return CreateDIBSection(hDC, &bi, DIB_RGB_COLORS, NULL, NULL, NULL);
}

void RenderAnimation(IN HWND hWnd) {

    static DWORD nDelay = 0;

    DWORD nTick = GetTickCount();
    if (nDelay == 0) { nDelay = nTick + gn_DELAY; }
    if (nTick > nDelay) {
        nDelay = 0;

        if (IsWindowVisible(hWnd)) {
            if (ghImg) {
                LONG_PTR graphics = 0;
                RECT r = {0};
                POINT lp = {0}, ptSrc = {0};
                SIZEL lpSize = {0};
            
                GetWindowRect(hWnd, &r);
                lpSize.cx = r.right - r.left; lpSize.cy = r.bottom - r.top;
                lp.x = r.left; lp.y = r.top;

                if (g_hBitmap == 0) { 
                    HDC DesktopDC = GetDC(0);
                    g_hDC = CreateCompatibleDC(DesktopDC);
                    g_hBitmap = zCreateDIBSection(g_hDC, lpSize.cx, lpSize.cy, 32);
                    SelectObject(g_hDC, g_hBitmap);
                    ReleaseDC(0, DesktopDC);
                }
                if (g_hBitmap) {

                    // Create a GDI32 transparent brush, to clear the background of our permanent bitmap.
                    SetRect(&r, 0, 0, lpSize.cx, lpSize.cy);
                    HGDIOBJ hBrush = CreateSolidBrush(NULL);
                    SelectObject (g_hDC, hBrush);
                    FillRect(g_hDC, &r, (HBRUSH) hBrush);
                    DeleteObject(hBrush);

                    if (GdipCreateFromHDC(g_hDC, graphics) == 0) {
                        gn_FrameToUse += 1; if (gn_FrameToUse > gn_FrameCount) { gn_FrameToUse = 1; }
                        if (ghImg) {
                            if (gn_IsHorizontal) {
                                GdipDrawImageRectRectI(graphics, ghImg, 0, 0, gn_H, gn_H, gn_H * gn_FrameToUse - gn_H, 0, gn_H, gn_H, 2, 0, NULL, NULL); }
                            else {
                                GdipDrawImageRectRectI(graphics, ghImg, 0, 0, gn_W, gn_W, gn_W * gn_FrameToUse - gn_W, 0, gn_W, gn_W, 2, 0, NULL, NULL);
                            }
                        }
                        GdipDeleteGraphics(graphics);
                    }

                    // Warning we use a permanent DC (CS_OWNDC)
                    BitBlt(GetDC(hWnd), 0, 0, lpSize.cx, lpSize.cy, g_hDC, 0, 0, SRCCOPY);

                }
            }
        }
    }
}

void Animate (IN LPVOID Delay) {
    DWORD nWait = 0;
    long nFrame;
    for (;;) {

        if (IsWindowVisible(g_hMain)) {
            if (ghImg) {
                LONG_PTR graphics = 0;
                RECT r = {0};
                POINT lp = {0}, ptSrc = {0};
                SIZEL lpSize = {0};
            
                GetWindowRect(g_hMain, &r);
                lpSize.cx = r.right - r.left; lpSize.cy = r.bottom - r.top;
                lp.x = r.left; lp.y = r.top;

                if (g_hBitmap == 0) { 
                    HDC DesktopDC = GetDC(0);
                    g_hDC = CreateCompatibleDC(DesktopDC);
                    g_hBitmap = zCreateDIBSection(g_hDC, lpSize.cx, lpSize.cy, 32);
                    SelectObject(g_hDC, g_hBitmap);
                    ReleaseDC(0, DesktopDC);
                }
                if (g_hBitmap) {

                    // Create a GDI32 transparent brush, to clear the background of our permanent bitmap.
                    SetRect(&r, 0, 0, lpSize.cx, lpSize.cy);
                    HGDIOBJ hBrush = CreateSolidBrush(NULL);
                    SelectObject (g_hDC, hBrush);
                    FillRect(g_hDC, &r, (HBRUSH) hBrush);
                    DeleteObject(hBrush);

                    if (GdipCreateFromHDC(g_hDC, graphics) == 0) {
                        gn_FrameToUse += 1; if (gn_FrameToUse > gn_FrameCount) { gn_FrameToUse = 1; }
                        if (ghImg) {
                            if (gn_IsHorizontal) {
                                GdipDrawImageRectRectI(graphics, ghImg, 0, 0, gn_H, gn_H, gn_H * gn_FrameToUse - gn_H, 0, gn_H, gn_H, 2, 0, NULL, NULL); }
                            else {
                                GdipDrawImageRectRectI(graphics, ghImg, 0, 0, gn_W, gn_W, gn_W * gn_FrameToUse - gn_W, 0, gn_W, gn_W, 2, 0, NULL, NULL);
                            }
                        }
                        GdipDeleteGraphics(graphics);
                    }

                    // Warning we use a permanent DC (CS_OWNDC)
                    BitBlt(GetDC(g_hMain), 0, 0, lpSize.cx, lpSize.cy, g_hDC, 0, 0, SRCCOPY);

                }
            }
        }

        Sleep((long) gn_DELAY);
    }
}

long StartAnimation (IN long Delay) {
    long nRet = LB_ERR;
    gn_DELAY = Delay;
    DWORD dwThreadId = 0;
    HANDLE hThread = CreateThread(NULL,                                  // default security attributes
                                  0,                                     // use default stack size  
                                  (LPTHREAD_START_ROUTINE ) Animate,     // thread function name
                                  (LPVOID) Delay,                        // argument to thread function 
                                  0,                                     // use default creation flags 
                                  &dwThreadId);                          // returns the thread identifier
    if (hThread) { nRet = 0; Sleep(100); }
    CloseHandle(hThread);
    return nRet;
}

void SpinnerInit (IN HWND hParent, IN HWND hWnd, IN WCHAR* szFileName, IN long nSpeedDelay) {

    if (IsWindow(hParent) == 0) { hParent = GetDesktopWindow(); }

    gn_FrameCount = 0;
    if (ghImg) { GdipDisposeImage(ghImg); ghImg = 0; }

    if (GdipLoadImageFromFile(szFileName, ghImg) == 0) {
        GdipGetImageWidth(ghImg, gn_W);
        GdipGetImageHeight(ghImg, gn_H);
        if (gn_W > gn_H) {
            gn_FrameCount = gn_W / gn_H;
            gn_IsHorizontal = -1; }
        else {
            gn_FrameCount = gn_H / gn_W;
            gn_IsHorizontal = 0;
        }

        RECT rw = {0}; GetWindowRect(hParent, &rw);
        MoveWindow(hWnd, rw.left + ((rw.right - rw.left - gn_H) / 2), rw.top + ((rw.bottom - rw.top - gn_H) / 2), gn_H, gn_H, 0);

        if (zDwmIsCompositionEnabled()) {
            zSetCrystalBehindMode(hWnd, TRUE);
        }
        
        if (nSpeedDelay == 0) {
            if (gn_FrameCount < 4) {
                gn_DELAY = 75; }
            else if (gn_FrameCount < 8) {
                gn_DELAY = 50; }
            else if (gn_FrameCount < 12) {
                gn_DELAY = 37; }
            else {
                gn_DELAY = TIMER_DELAY;
            }
        }

//        SetTimer(hWnd, TIMER_SPINNER, 0, 0); // 66 FPS
        g_hMain = hWnd; StartAnimation(gn_DELAY);

    }
}

LRESULT CALLBACK SpinnerProc (IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {
    switch (uMsg) {
    case WM_KEYDOWN:
         if (wParam == VK_ESCAPE) { DestroyWindow(hWnd); }
         break;

    case WM_TIMER:
         RenderAnimation(hWnd);
         break;

    case WM_NCHITTEST:
         return HTCAPTION;

    case WM_DESTROY:
         if (g_hBitmap) { DeleteObject(g_hBitmap); }
         if (g_hDC) { DeleteDC(g_hDC); }
         KillTimer(hWnd, TIMER_SPINNER);
         PostQuitMessage(0);
         if (ghImg) { GdipDisposeImage(ghImg); ghImg = 0; }
         return 0;
    }
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {
    long nRet = 0;
    HWND hWnd = 0, hParent = 0;
    long nSpeedDelay = 0;
    MSG msg = {0};
    WNDCLASSEX wcx = {0};
    WCHAR szClassName[] = L"ZSPIN_DWM";
    WCHAR szFileName[MAX_PATH] = {0};

    wcx.cbSize = sizeof(wcx);
    long IsInitialized = GetClassInfoEx(hInstance, szClassName, &wcx);
    if (IsInitialized   == 0) {
        wcx.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
        wcx.lpfnWndProc   = &SpinnerProc;
        wcx.cbClsExtra    = 0;
        wcx.cbWndExtra    = 0;
        wcx.hInstance     = hInstance;
        wcx.hIcon         = NULL;
        wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wcx.hbrBackground = NULL;
        wcx.lpszMenuName  = NULL;
        wcx.lpszClassName = szClassName;
        wcx.hIconSm       = wcx.hIcon;
        if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
    }

    if (IsInitialized) {
        hWnd = CreateWindowEx(WS_EX_TOOLWINDOW | WS_EX_TOPMOST, szClassName, szClassName, WS_POPUP | WS_VISIBLE,
                              0, 0, 0, 0, NULL, (HMENU) NULL, hInstance, NULL);
        if (hWnd) {

            LONG_PTR hGDIplus = 0;
            wcscpy_s(szFileName, lpCmdLine);
            if (IsFile(szFileName)) {
                hGDIplus = GdipStart(); if (hGDIplus) { SpinnerInit (hParent, hWnd, szFileName, nSpeedDelay); }
            }
            if (hGDIplus == 0) { DestroyWindow(hWnd); }

            UpdateWindow(hWnd);

            while (GetMessage(&msg, NULL, 0, 0)) {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            if (hGDIplus) { GdipEnd(hGDIplus); }
            nRet = (long) msg.wParam;
        }
    }
    return nRet;
}
